/*
 * Copyright 2016 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.stunner.core.rule.graph;

import org.kie.workbench.common.stunner.core.graph.Edge;
import org.kie.workbench.common.stunner.core.graph.Graph;
import org.kie.workbench.common.stunner.core.graph.Node;
import org.kie.workbench.common.stunner.core.graph.content.view.View;
import org.kie.workbench.common.stunner.core.rule.CardinalityRuleManager;
import org.kie.workbench.common.stunner.core.rule.RuleViolations;

/**
 * Manager for cardinality rules specific for Stunner's graph domain.
 */
public interface GraphCardinalityRuleManager
        extends CardinalityRuleManager {

    /**
     * It checks cardinality rules and evaluates if the given candidate node can be added or removed
     * from the graph.
     * @param graph The graph.
     * @param candidates The node to add or remove.
     * @param operation Add or remove
     */
    RuleViolations evaluate(final Graph<?, ? extends Node> graph,
                            final Node<? extends View<?>, ? extends Edge> candidates,
                            final Operation operation);
}
